<?php
$result_text = '';
$GLOBALS['connect'] = mysqli_connect('localhost', 'felhasználónév', 'jelszó', 'adatbázis');

function clear_tags($text)
	{
	//az alábbi két függvényt tulajdonságai szerint mindenki maga eldöntheti, hogy melyiket szeretné használni, nem kötelező mind a kettő függvényt egyszerre használni, hiszen a leírásból ki fog derülni, hogy nem ugyan arra a feladatra vannak kitalálva
	$text = strip_tags($text); //minden hrml, css és javascript tag-et el fog tűntetni
	$text = htmlspecialchars($text); //minden relációs jelet át fog alakítani: "<"-jelből "&lt;" lesz és ">"-jelből "&gt;" lesz. Előnye, hogy a kód megjelenik, de nem fut le 

	return $text;
	}

function clear_sql_injection($text)
	{
	$text = stripslashes($text); //minden aposztróf elé be fog tenni egy "\"-jelet, ez főleg akkor előnyös, ha azonos típusú aposztróf kerül be a lekérdezésbe, mint amit a lekérdezés a karakterláncok összehasonlítására használna és ezzel megakasztaná az utasítás lefutását
	$text = mysqli_real_escape_string($GLOBALS['connect'], $text); //megakadályozza, hogy olyan karakterlánc kerüljön be a lekérdezésbe, ami egy SQL utasításnak felelne meg

	return $text;
	}

if (filter_input(INPUT_POST, 'login'))
	{
	/*
	foreach ($_POST as $index => $value)
		{
		$_POST[$index] = clear_tags($_POST[$index]);
		$_POST[$index] = clear_sql_injection($_POST[$index]);
		}
	*/

	//A fenti kikommentelt kódrész ugyan azt valósítja meg, mint az "array_map" függvény, de a példa kedvéért bemutatom mind a két megoldást.
	$_POST = array_map('clear_tags', $_POST);
	$_POST = array_map('clear_sql_injection', $_POST);

	$email_slug_array = explode('@', $_POST['email']);
	$domain = array_pop($email_slug_array);

	if ((filter_input(INPUT_POST, 'email', FILTER_VALIDATE_EMAIL)) && ((checkdnsrr($domain, 'MX')) || (checkdnsrr($domain, 'A'))) && (filter_input(INPUT_POST, 'password')))
		{
		$select_user = mysqli_query($GLOBALS['connect'], "SELECT * FROM users WHERE (((((email = '".$_POST['email']."'))) AND (((password = '".md5($_POST['password'])."'))))) AND login_access <= '".time()."' LIMIT 1");
		if (mysqli_num_rows($select_user) == 1)
			{
			$data_user = mysqli_fetch_assoc($select_user);
			$result_text = '<p class="alert alert-success">'.$data_user['username'].' sikeresen bejelentkezett!</p>';
			}
		else
			{
			$result_text = '<p class="alert alert-danger">A bejelentkezés nem sikerült. A felhasználónév és jelszó páros nem volt megfelelő!</p>';

			$select_log = mysqli_query($GLOBALS['connect'], "SELECT * FROM login_log WHERE email = '".$_POST['email']."' AND time >= '".(time() - 360)."' ORDER BY time ASC LIMIT 3");
			if (mysqli_num_rows($select_log) == 3)
				{
				$i = 1;
				$time_interval = 0;
				while ($data_log = mysqli_fetch_assoc($select_log))
					{
					if ($i == 1)
						{
						$time_interval = $data_log['time'];
						}
					elseif ($i == 2)
						{
						$time_interval -= $data_log['time'];
						}

					$i++;
					}

				if ($time_interval < 60)
					{
					mysqli_query($GLOBALS['connect'], "UPDATE users SET login_access = '".(time() + 3600)."' WHERE (((email = '".$_POST['email']."'))) LIMIT 1");
					}
				}
			else
				{
				mysqli_query($GLOBALS['connect'], "INSERT INTO login_log (email, time) VALUES ('".$_POST['email']."', '".time()."')");
				}
			}
		}
	else
		{
		$result_text = '<p class="alert alert-danger">A bejelentkezés nem sikerült. A felhasználónév és jelszó páros nem volt megfelelő!</p>';
		}
	}
?>
<!DOCTYPE html>
<html lang="hu-HU">
<head>
	<meta charset="utf-8">

	<title>PHP: Biztonságos bejelentkezés | Webmestertanfolyam.hu</title>

	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1" />
	<link type="text/css" rel="stylesheet" href="css/bootstrap.min.css" rel="stylesheet" />
	<!--[if lt IE 9]>
		<script type="text/javascript" src="//html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="css/styles.css" rel="stylesheet" />
</head>
<body>
	<div class="navbar navbar-default">
		<div class="container">
			<a class="navbar-brand" href="http://webmestertanfolyam.hu" title="Webmestertanfolyam.hu" target="_blank"><img src="http://webmestertanfolyam.hu/img/logo-demo.png" alt="Webmestertanfolyam.hu" /></a>
			<ul class="nav navbar-nav">
				<li><a href="http://webmestertanfolyam.hu/#tanfolyamaink" title="Tanfolyamaink" target="_blank">Tanfolyamaink</a></li>
				<li><a href="http://webmestertanfolyam.hu/webmester-blog" title="További segédletek" target="_blank">További segédletek</a></li>
			</ul>
		</div>
	</div>

	<div class="container">
		<div class="row">
			<div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
				<h4>Jelentkezz be valamelyik felhasználóval</h4>

				<?php echo $result_text; ?>
				<form name="login" method="post" action="index.php">
					<input type="email" name="email" placeholder="E-mail cím" class="form-control" required /><br/>
					<input type="password" name="password" placeholder="Jelszó" class="form-control" required /><br/>
					<input type="submit" name="login" value="Bejelentkezés" class="btn btn-lg btn-success" />
				</form>

				<br/><br/>
				<p>Segítség képpen, az alábbi teszt felhasználók vannak az adatbázisban</p>
				<p>
					Teszt Elek, elek@webmestertanfolyam.hu, 123456<br/>
					Kiss Pista, pista@webmestertanfolyam.hu, 123456<br/>
					Gipsz Jakab, jakab@webmestertanfolyam.hu, 123456<br/>
				</p>
			</div>
		</div>

		<hr/>

		<div class="jumbotron text-center">
			<h1>PHP: Biztonságos bejelentkezés</h1>
			<p class="lead">A demo forrása: <a href="http://webmestertanfolyam.hu" title="webmestertanfolyam.hu" target="_blank">webmestertanfolyam.hu</a></p>
			<p><a class="btn btn-lg btn-success" href="http://webmestertanfolyam.hu/webmester-blog" title="További segédletek" target="_blank">További segédletek</a></p>
		</div>
	</div>

	<script type="text/javascript" src="js/jquery-1.9.1.min.js"></script>
	<script type="text/javascript" src="js/bootstrap.min.js"></script>
</body>
</html>